# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.CivicInfo.V2.Model.ElectionOfficial do
  @moduledoc """
  Information about individual election officials.

  ## Attributes

  *   `emailAddress` (*type:* `String.t`, *default:* `nil`) - The email address of the election official.
  *   `faxNumber` (*type:* `String.t`, *default:* `nil`) - The fax number of the election official.
  *   `name` (*type:* `String.t`, *default:* `nil`) - The full name of the election official.
  *   `officePhoneNumber` (*type:* `String.t`, *default:* `nil`) - The office phone number of the election official.
  *   `title` (*type:* `String.t`, *default:* `nil`) - The title of the election official.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :emailAddress => String.t(),
          :faxNumber => String.t(),
          :name => String.t(),
          :officePhoneNumber => String.t(),
          :title => String.t()
        }

  field(:emailAddress)
  field(:faxNumber)
  field(:name)
  field(:officePhoneNumber)
  field(:title)
end

defimpl Poison.Decoder, for: GoogleApi.CivicInfo.V2.Model.ElectionOfficial do
  def decode(value, options) do
    GoogleApi.CivicInfo.V2.Model.ElectionOfficial.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.CivicInfo.V2.Model.ElectionOfficial do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
