# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.CivicInfo.V2.Model.ElectionsQueryResponse do
  @moduledoc """
  The list of elections available for this version of the API.

  ## Attributes

  *   `elections` (*type:* `list(GoogleApi.CivicInfo.V2.Model.Election.t)`, *default:* `nil`) - A list of available elections
  *   `kind` (*type:* `String.t`, *default:* `civicinfo#electionsQueryResponse`) - Identifies what kind of resource this is. Value: the fixed string "civicinfo#electionsQueryResponse".
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :elections => list(GoogleApi.CivicInfo.V2.Model.Election.t()),
          :kind => String.t()
        }

  field(:elections, as: GoogleApi.CivicInfo.V2.Model.Election, type: :list)
  field(:kind)
end

defimpl Poison.Decoder, for: GoogleApi.CivicInfo.V2.Model.ElectionsQueryResponse do
  def decode(value, options) do
    GoogleApi.CivicInfo.V2.Model.ElectionsQueryResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.CivicInfo.V2.Model.ElectionsQueryResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
